package com.jcg.examples.demo.books;

import java.util.Collection;
import java.util.stream.Collectors;

import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.CrossOrigin;

@RestController

public class BookController {
    private BookRepository repository;

    public BookController(BookRepository repository) {
        this.repository = repository;
    }

    @GetMapping("/good-books")
    @CrossOrigin(origins = "http://localhost:3000")
    public Collection<Book> goodBooks() {
        return repository.findAll().stream()
                .filter(this::isAvailable)
                .collect(Collectors.toList());
    }

    private boolean isAvailable(Book Book) {
        return !Book.getName().equals("Les Miserables") &&
                !Book.getName().equals("The History of the World");   
    }
}