package com.jcg.examples.demo.books;

import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import java.util.stream.Stream;

@Component
public class BookCommandLineRunner implements CommandLineRunner {
	private final BookRepository repository;

	public BookCommandLineRunner(BookRepository repository) {
		this.repository = repository;
	}

	@Override
	public void run(String... strings) throws Exception {
		Stream.of("Macbeth", "Othello", "The Lord of the Rings", "The Bourne Identity", "Goodnight Moon",
				"The Mysterious Affair at Styles", "The A.B.C Murders", "Les Miserables", "The History of the World",
				"The Apocalypse Watch", "The Materese Circle").forEach(name -> repository.save(new Book(name)));
		repository.findAll().forEach(System.out::println);
	}
}